/*
 * Copyright (C) 2009 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gameproject.multiplayerpaddle;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.UUID;

import android.annotation.TargetApi;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothServerSocket;
import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

/**
 * Ta klasa wykonuje całą pracę związaną z konfiguracją i zarządzaniem połączeniami Bluetooth
 * z innymi urządzeniam. Posiada ona wątek nasłuchujący połączeń przychodzących 
 * wątek połączenia z urządzeniem i wątek
 * wysyłający dane po połączeniu
 */
@TargetApi(11)
public class BluetoothChatService {
    // Debugowanie
    private static final String TAG = "BluetoothChatService";
    private static final boolean D = true;

 // Nazwa rekordu SDP używana podczas tworzenia gniazda serwera
    private static final String NAME = "BluetoothChat";

 // Niepowtarzalny identyfikator UUID tej aplikacji
    private static final UUID MY_UUID = UUID.fromString("fa87c0d0-afac-11de-8a39-0800200c9a66");

 // Pola klasy
    private final BluetoothAdapter mAdapter;
    private final Handler mHandler;
    private AcceptThread mAcceptThread;
    private ConnectThread mConnectThread;
    private ConnectedThread mConnectedThread;
    private int mState;

 // Stałe wskazujące bieżący stan połączenia
    public static final int STATE_NONE = 0;       // nic nie robimy
    public static final int STATE_LISTEN = 1;     // słuchamy nadchodzących połączeń
    public static final int STATE_CONNECTING = 2; // tworzymy połączenie wychodzące
    public static final int STATE_CONNECTED = 3;  // połączony z urządzeniem zdalnym

    /**
     * Konstruktor. Przygotowuje nową sesję Bluetooth.
     * @param context  Kontekst Aktywności
     * @param handler  Procedura obsługi wysyłająca komunikat do Aktywności
     */
    public BluetoothChatService(Context context, Handler handler) {
        mAdapter = BluetoothAdapter.getDefaultAdapter();
        mState = STATE_NONE;
        mHandler = handler;
    }

    /**
     * Ustawia bieżący stan połączenia
     * @param state  Wartość całkowitoliczbowa określająca stan połączenia
     */
    private synchronized void setState(int state) {
        if (D) Log.d(TAG, "setState() " + mState + " -> " + state);
        mState = state;

     // Przekaż bieżąc stan do metody obsługi
        mHandler.obtainMessage(BluetoothChat.MESSAGE_STATE_CHANGE, state, -1).sendToTarget();
    }

    /**
     * Zwraca bieżący stan połączenia. */
    public synchronized int getState() {
        return mState;
    }

    /**
     * Uruchamia usługę komunikacji. W szczególności uruchamia wątek AcceptThread aby rozpocząć
     * sesję w trybie nasłuchowania. Wywoływana przez metodę onResume() klasy Activity*/
    public synchronized void start() {
        if (D) Log.d(TAG, "start");

     // Usuń dowolny wątek próbujący nawiązać połączenie 
        if (mConnectThread != null) {mConnectThread.cancel(); mConnectThread = null;}

        // Usuń dowolny wątek obsługujący połączenie
        if (mConnectedThread != null) {mConnectedThread.cancel(); mConnectedThread = null;}

      // Uruchom wątek nasłuchujący na gnieździe Bluetooth 
        if (mAcceptThread == null) {
            mAcceptThread = new AcceptThread();
            mAcceptThread.start();
        }
        setState(STATE_LISTEN);
    }

    /**
     * Uruchom wątek ConnectThread w celu rozpocząecia połączenia ze zdalnym urządzeniem.
     * @param device  Urządzenie BluetoothDevice z którym należy nawiązać połączenie
     */
    public synchronized void connect(BluetoothDevice device) {
        if (D) Log.d(TAG, "połącz z: " + device);

     // Usuń dowolny wątek próbujący nawiązać połączenie
        if (mState == STATE_CONNECTING) {
            if (mConnectThread != null) {mConnectThread.cancel(); mConnectThread = null;}
        }

     // Usuń dowolny wątek obsługujący połączenie
        if (mConnectedThread != null) {mConnectedThread.cancel(); mConnectedThread = null;}

     // Uruchom wątek w celu nawiązania połączenia z danym urządzeniem
        mConnectThread = new ConnectThread(device);
        mConnectThread.start();
        setState(STATE_CONNECTING);
    }

    /**
     * Uruchamia wątek ConnectedThread w celu nadzorowania bieżącego połączenia Bluetooth
     * @param socket  Obiekt BluetoothSocket użyty do nawiązania połączenia
     * @param device  Obiekt BluetoothDevice z którym urządzenie jest połączone
     */
    public synchronized void connected(BluetoothSocket socket, BluetoothDevice device) {
        if (D) Log.d(TAG, "połączony");

     // Usuń wątek, który ukończył połączenie 
        if (mConnectThread != null) {mConnectThread.cancel(); mConnectThread = null;}

     // Usuń dowolny wątek obsługujący połączenie 
        if (mConnectedThread != null) {mConnectedThread.cancel(); mConnectedThread = null;}

     // Usuń wątek AcceptThread, ponieważ chcemy połączyć się tylko z jednym urządzeniem 
        if (mAcceptThread != null) {mAcceptThread.cancel(); mAcceptThread = null;}

     // Uruchom wątek w celu zarządzania połączeniem i transmisją 
        mConnectedThread = new ConnectedThread(socket);
        mConnectedThread.start();

     // Wyślij nawę połączonego urządzenia z powrotem do Aktywności
        Message msg = mHandler.obtainMessage(BluetoothChat.MESSAGE_DEVICE_NAME);
        Bundle bundle = new Bundle();
        bundle.putString(BluetoothChat.DEVICE_NAME, device.getName());
        msg.setData(bundle);
        mHandler.sendMessage(msg);

        setState(STATE_CONNECTED);
    }

    /**
     * Zatrzymuje wszystkie wątki
     */
    public synchronized void stop() {
        if (D) Log.d(TAG, "stop");
        if (mConnectThread != null) {mConnectThread.cancel(); mConnectThread = null;}
        if (mConnectedThread != null) {mConnectedThread.cancel(); mConnectedThread = null;}
        if (mAcceptThread != null) {mAcceptThread.cancel(); mAcceptThread = null;}
        setState(STATE_NONE);
    }

    /**
     * Zapisuje do wątku ConnectedThread w sposób niesynchronizowany
     * @param out bajty do zapisu
     * @see ConnectedThread#write(byte[])
     */
    public void write(byte[] out) {
    	// Utwórz obiekt tymczasowy 
        ConnectedThread r;
        // Synchronizuj kopię wątku ConnectedThread 
        synchronized (this) {
            if (mState != STATE_CONNECTED) return;
            r = mConnectedThread;
        }
     // Wykonaj niesynchronizowany zapis
        r.write(out);
    }

    /**
     * Wskazuje błąd połączenia.
     */
    private void connectionFailed() {
        setState(STATE_LISTEN);

     // Wyślij komunikat o błędzie z powrotem do aktywności 
        Message msg = mHandler.obtainMessage(BluetoothChat.MESSAGE_TOAST);
        Bundle bundle = new Bundle();
        bundle.putString(BluetoothChat.TOAST, "Błąd połączenia z urządzeniem");
        msg.setData(bundle);
        mHandler.sendMessage(msg);
    }

    /**
     * Wskazuje utratę połączenia.
     */
    private void connectionLost() {
        setState(STATE_LISTEN);

     // Wyślij komunikat o błędzie z powrotem do aktywności
        Message msg = mHandler.obtainMessage(BluetoothChat.MESSAGE_TOAST);
        Bundle bundle = new Bundle();
        bundle.putString(BluetoothChat.TOAST, "Utracono połączenie z urządzeniem");
        msg.setData(bundle);
        mHandler.sendMessage(msg);
    }

    /**
     * Ten wątek działa w trakcie nasłuchiwania nadchodzących połączeń. Działa on jako klient po stronie serwea
     * Wątek działa do czasu nawiązania połączenia (lub jego anulowania)
     */
    private class AcceptThread extends Thread {
    	// Gniazdo serwera lokalnego 
        private final BluetoothServerSocket mmServerSocket;

        public AcceptThread() {
            BluetoothServerSocket tmp = null;

         // Utwórz nowe nasłuchujące gniazdo serwera
            try {
                tmp = mAdapter.listenUsingRfcommWithServiceRecord(NAME, MY_UUID);
            } catch (IOException e) {
                Log.e(TAG, "błąd funkcji listen()", e);
            }
            mmServerSocket = tmp;
        }

        public void run() {
            if (D) Log.d(TAG, "START mAcceptThread" + this);
            setName("AcceptThread");
            BluetoothSocket socket = null;

         // Dopóki brak jest połączenia, nasłuchuj na gnieździe sieciowym 
            while (mState != STATE_CONNECTED) {
                try {
                	// To jest wywołanie blokujące, które zwróci wartość jedynie w przypadku
                	// nawiązania poprawnego połączenia lub wystąpienia wyjątku 
                    socket = mmServerSocket.accept();
                } catch (IOException e) {
                    Log.e(TAG, "błąd funkcji accept()", e);
                    break;
                }

             // Po zaakceptowaniu połączenia
                if (socket != null) {
                    synchronized (BluetoothChatService.this) {
                        switch (mState) {
                        case STATE_LISTEN:
                        case STATE_CONNECTING:
                        	// Sytuacja poprawna. Uruchom wątek połączenia
                            connected(socket, socket.getRemoteDevice());
                            break;
                        case STATE_NONE:
                        case STATE_CONNECTED:
                        	// Połączenie aktywne lub brak gotowości. Usuń nowe gniazdo 
                            try {
                                socket.close();
                            } catch (IOException e) {
                                Log.e(TAG, "Błąd zamykania zbędnego gniazda", e);
                            }
                            break;
                        }
                    }
                }
            }
            if (D) Log.i(TAG, "KONIEC mAcceptThread");
        }

        public void cancel() {
            if (D) Log.d(TAG, "anulowanie " + this);
            try {
                mmServerSocket.close();
            } catch (IOException e) {
                Log.e(TAG, "błąd funkcji close()", e);
            }
        }
    }


    /**
     * Ten wątek działa w trakcie próby nawiązania połączenia wychodzącego
     * Działa on bardzo prosto - połączenie kończy się sukcesem lub porażką
     */
    private class ConnectThread extends Thread {
        private final BluetoothSocket mmSocket;
        private final BluetoothDevice mmDevice;

        public ConnectThread(BluetoothDevice device) {
            mmDevice = device;
            BluetoothSocket tmp = null;

            // Pobierz gniazdo Bluetooth dla połączenia
            // z danym urządzeniem Bluetooth 
            try {
                tmp = device.createRfcommSocketToServiceRecord(MY_UUID);
            } catch (IOException e) {
                Log.e(TAG, "błąd funkcji create()", e);
            }
            mmSocket = tmp;
        }

        public void run() {
            Log.i(TAG, "START mConnectThread");
            setName("ConnectThread");

         // Należy zawsze unikać fazy discovery, ponieważ zdecydowanie spowalnia ona połączenie 
            mAdapter.cancelDiscovery();

         // Nawiąż połączenie z gniazdem Bluetooth 
            try {
            	// To jest wywołanie blokujące, które zwróci wartość jedynie w przypadku
            	// nawiązania poprawnego połączenia lub wystąpienia wyjątku 
                mmSocket.connect();
            } catch (IOException e) {
                connectionFailed();
             // Zamknij gniazdo 
                try {
                    mmSocket.close();
                } catch (IOException e2) {
                    Log.e(TAG, "błąd zamykania gniazda spowodowany błędem połączenia", e2);
                }
             // Ponownie uruchom usługę w trybie nasłuchu 
                BluetoothChatService.this.start();
                return;
            }

         // Wyzeruj zmienną mConnectThread 
            synchronized (BluetoothChatService.this) {
                mConnectThread = null;
            }

         // Uruchom wątek połączenia 
            connected(mmSocket, mmDevice);
        }

        public void cancel() {
            try {
                mmSocket.close();
            } catch (IOException e) {
                Log.e(TAG, "błąd funkcji close()", e);
            }
        }
    }

    /**
     * Ten wątek działa podczas połączenia ze zdalnym urządzeniem.
     * obsługuje on cała transmisję wychodzącą oraz przychodzącą
     */
    private class ConnectedThread extends Thread {
        private final BluetoothSocket mmSocket;
        private final InputStream mmInStream;
        private final OutputStream mmOutStream;

        public ConnectedThread(BluetoothSocket socket) {
            Log.d(TAG, "utwórz ConnectedThread");
            mmSocket = socket;
            InputStream tmpIn = null;
            OutputStream tmpOut = null;

            // Get the BluetoothSocket input and output streams
            try {
                tmpIn = socket.getInputStream();
                tmpOut = socket.getOutputStream();
            } catch (IOException e) {
                Log.e(TAG, "błąd tworzenia gniazd tymczasowyc", e);
            }

            mmInStream = tmpIn;
            mmOutStream = tmpOut;
        }

        public void run() {
            Log.i(TAG, "START mConnectedThread");
            byte[] buffer = new byte[1024];
            int bytes;

         // Dopóki jest połączenie, nasłuchuj strumień wejściowy
            while (true) {
                try {
                	// Czytaj ze strumienia wejściowego 
                    bytes = mmInStream.read(buffer);

                 // Wyślij otrzymane bajty do głównej aktywności
                    mHandler.obtainMessage(BluetoothChat.MESSAGE_READ, bytes, -1, buffer)
                            .sendToTarget();
                } catch (IOException e) {
                    Log.e(TAG, "rozłączony", e);
                    connectionLost();
                    break;
                }
            }
        }

        /** 
         * Zapisz do podłączonego strumienia OutStream. 
         * @param buffer  Bajty do zapisu 
         */ 
        public void write(byte[] buffer) {
            try {
                mmOutStream.write(buffer);

             // Udostępnij wysłany komunikat głównej aktywności
                mHandler.obtainMessage(BluetoothChat.MESSAGE_WRITE, -1, -1, buffer)
                        .sendToTarget();
            } catch (IOException e) {
                Log.e(TAG, "Wyjątek podczas zapisu", e);
            }
        }

        public void cancel() {
            try {
                mmSocket.close();
            } catch (IOException e) {
                Log.e(TAG, "błąd funkcji close()", e);
            }
        }
    }
}
